package riomhaire.lti.core.model.interfaces;

import org.springframework.web.servlet.ModelAndView;
import riomhaire.lti.core.model.LTIMessage;

/**
 * This is the minimal Registry info on the environment. Its the context within which commands run and can get
 * Access to other components
 */
public interface ApplicationRegistry {

    // This is a entity which allows tool to verify token etc is from some reputible source
    // The default implementation is a caller to redis where we have information on a deployed registered tool
    // And where to find the JWKS etc
    ClientRegistrationResolver clientRegistrationResolver();

    // command dispatcher... this is the entity that stores a mapping between a message type and its handler
    // command. It looks up the message type and delegates to a command to handle it. There is a default command
    // handler if no command has been registered. At the moment its a 1-1 mapping
    CommandDispatcher<ModelAndView, ApplicationRegistry, LTIMessage> commandDispatcher();
}
